****************************************
*       RICHEDITBOX Copy & Paste       *
*                                      *
*   Ciro Vargas Clemow   Junio 2010    *
*                                      *
*   Assembly: mustalopez@gmail.com     *
*                                      *    
****************************************

#include "minigui.ch"
#define CR_LF CHR(13)+CHR(10)

PROCEDURE Main

   DEFINE WINDOW Form_1 ;
      AT 0,0 ;
      WIDTH 600 ;
      HEIGHT 400 ;
      TITLE ' RICHEDITBOX Copy & Paste ' ;
      MAIN NOMAXIMIZE
  
      DEFINE CONTEXT MENU
            MENUITEM 'Cut'    ACTION send_CUT()
            MENUITEM 'Copy'   ACTION send_COPY()
            MENUITEM 'Paste'  ACTION send_paste()
            MENUITEM 'Delete' Action _PushKey ( 32 )
            SEPARATOR
            MENUITEM 'Select all' ACTION send_selectall()
     END MENU

*-----------------------------------------------------------------------------------------------------------*
          @ 330,150 LABEL Label_01 VALUE '[ Copy ->  Ctrl+C ]   [ Paste -> Ctrl + V ]'  CENTERALIGN ;    
                    FONT "Arial" SIZE 9 BOLD ITALIC  BACKCOLOR {016,000,100} FONTCOLOR {180,200,255}  ;
                    WIDTH 300 HEIGHT 20   

  
             fEchac := 'Notes: ' + SPACE(2) + DTOC(DATE()) + SPACE(3) + TIME() + CR_LF 
  
             DEFINE RICHEDITBOX RichEditBox_1
                    ROW    030
                    COL    030
                    WIDTH  530
                    HEIGHT 280       
                    VALUE  fEchac                           
                    FONTNAME "Arial"
                    FONTSIZE 10
                    TOOLTIP "Enter Text ..."
                    ONCHANGE Nil
                    ONGOTFOCUS Nil    
                    ONLOSTFOCUS Nil             
                    FONTBOLD .T.
                    FONTITALIC .T.
                    FONTUNDERLINE .F.     
                    FONTSTRIKEOUT .F.    
                    HELPID Nil
                    TABSTOP .T.   
                    VISIBLE .T.
                    READONLY .F.           
                    BACKCOLOR {253,254,184}              
            END RICHEDITBOX
  

   END WINDOW

   CENTER WINDOW Form_1

   ACTIVATE WINDOW Form_1

Return

#pragma BEGINDUMP

#include <windows.h>

#include <winuser.h>

#include "hbapi.h"

#define VK1_A 65
#define VK1_C 67
#define VK1_V 86
#define VK1_X 88
/* select all - ctrl-a */
HB_FUNC( SEND_SELECTALL )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_A, MapVirtualKey(VK1_A, 0), 0, 0);
keybd_event(VK1_A, MapVirtualKey(VK1_A, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
/* copy - ctrl-c */
HB_FUNC( SEND_COPY )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_C, MapVirtualKey(VK1_C, 0), 0, 0);
keybd_event(VK1_C, MapVirtualKey(VK1_C, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
/* paste - ctrl-v */
HB_FUNC( SEND_PASTE )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_V, MapVirtualKey(VK1_V, 0), 0, 0);
keybd_event(VK1_V, MapVirtualKey(VK1_V, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
/* cut - ctrl-x */
HB_FUNC( SEND_CUT )
{
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
keybd_event(VK1_X, MapVirtualKey(VK1_X, 0), 0, 0);
keybd_event(VK1_X, MapVirtualKey(VK1_X, 0), KEYEVENTF_KEYUP, 0);
keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP,
0);
}
#pragma ENDDUMP
